/* Copyright (C) 1995,1996 Robert de Bath <rdebath@cix.compulink.co.uk>
 * This file is part of the Linux-8086 C library and is distributed
 * under the GNU Library General Public License.
 */

/****************************************************************************/

#ifdef L_errno
int errno = 0;	/* libc error value */
#endif

/****************************************************************************/

#ifdef L___brk_addr
#ifdef __AS386_16__
#asm
.data
export brk_addr
brk_addr: .word __end	! This holds the current return for sbrk(0)
.text
#endasm
#endif
#endif

/****************************************************************************/

#ifdef L_sbrk
#ifdef __AS386_16__
int sbrk(brk_off)
unsigned int brk_off;
{
#asm
  mov	bx,sp
#if !__FIRST_ARG_IN_AX__
  mov	ax,[bx+2]	! Fetch the requested value
#endif
  test	ax,ax
  js	go_down
  add	ax,[brk_addr]
  jc	too_big
  sub	bx,#64		! Safety space
  cmp	bx,ax		! Too close ?
  jb	too_big

down_ok:
  mov	[brk_addr],ax	! Save away new val
  jmp	eof		! Return it
go_down:
  add	ax,[brk_addr]
  jnc	too_big
  cmp	ax,#__end
  jae	down_ok

too_big:
  mov	ax,#12		! This should be ENOMEM not a magic.
  mov	[_errno],ax
  mov	ax,#-1
eof:
#endasm
}
#endif
#endif

/****************************************************************************/

