/* Copyright (C) 1995,1996 Robert de Bath <rdebath@cix.compulink.co.uk>
 * This file is part of the Linux-8086 C library and is distributed
 * under the GNU Library General Public License.
 */

#ifdef L_abs
int
abs(arg1)
int arg1;
{
   return arg1>0?arg1:-arg1;
}
#endif

#ifdef L_raise
int
raise(signo)
int signo;
{
   return kill(getpid(), signo);
}
#endif

#ifdef L_bcopy
void
bcopy(src, dest, len)
void * src, *dest;
unsigned int len;
{
   (void) memcpy(dest, src, len);
}
#endif

#ifdef L_bzero
void
bzero(dest, len)
void *dest;
unsigned int len;
{
   (void) memset(dest, '\0', len);
}
#endif

#ifdef L_bcmp
int
bcmp(dest, src, len)
void * src, *dest;
unsigned int len;
{
   return memcmp(dest, src, len);
}
#endif

#ifdef L_index
char *
index(src, chr)
char *src;
int chr;
{
   return strchr(src, chr);
}
#endif

#ifdef L_rindex
char *
rindex(src, chr)
char *src;
int chr;
{
   return strrchr(src, chr);
}
#endif

#ifdef L_remove
#include <errno.h>

int
remove(src)
char *src;
{
   extern int errno;
   int er = errno;
   int rv = unlink(src);
   if( rv < 0 && errno == EISDIR )
      rv = rmdir(src);
   if( rv >= 0 ) errno = er;
   return rv;
}
#endif

